<template>
	<div class="collect-map">
		<div class="progress-indicator" v-if="hasProgress && progress">
			<v-btn label color="white" class="mx-auto px-2" style="height: 29px" @click="$emit('clickProgress')">
				<v-icon small class="mr-1 ml-1"> mdi-triangle </v-icon>
				{{ progress }}
			</v-btn>
		</div>
		<mgl-map
			:layers="layers"
			:controls="controls"
			:eventHandlers="eventHandlers"
			:zoom="mapOptions.zoom"
			:maxBounds="mapOptions.maxBounds"
			:center="mapOptions.center"
			@locationClick="$emit('locationClick', $event)"
			@trackUserLocationStart="$emit('trackUserLocationStart', $event)"
			@trackUserLocationEnd="$emit('trackUserLocationEnd', $event)"
		/>
	</div>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import { Area } from '@/store/types';
import MglMap from '@/components/map/MglMap.vue';
import { ControlTypes } from '@/components/map/mglUtils';
import { FeatureCollection, Feature } from 'geojson';
import { locationsClickHandler, createLayers } from '@/components/map/mapUtils';
import { getMapOptionsForField } from '@/utils/mapFetching';

export default defineComponent({
	props: {
		hasProgress: {
			type: Boolean,
		},
		locations: {
			type: Object as () => FeatureCollection,
		},
		activeLocation: {
			type: Object as () => Feature,
		},
		area: {
			type: Object as () => Area,
		},
		hasInteractiveLocations: {
			type: Boolean,
			default: false,
		},
		hasGeolocateControl: {
			type: Boolean,
			default: false,
		},
	},
	components: {
		MglMap,
	},
	setup(props) {
		const mapOptions =
			props.area || props.locations
				? getMapOptionsForField((props.area as Area) || (props.locations as FeatureCollection))
				: {};

		const layers = computed(() =>
			createLayers({
				area: props.area as Area,
				locations: props.locations,
				activeLocation: props.activeLocation,
			})
		);

		const progress = computed(() => {
			if (props.locations) {
				const completed = props.locations.features.filter(
					(l: Feature) => l.properties?.markerType !== 'LOCATION_INCOMPLETE'
				).length;
				const total = props.locations.features.length;
				return `${completed} / ${total}`;
			}
		});

		return {
			layers,
			controls: props.hasGeolocateControl ? [ControlTypes.Geolocate] : [],
			eventHandlers: props.hasInteractiveLocations ? [locationsClickHandler] : [],
			progress,
			mapOptions,
		};
	},
});
</script>

<style scoped>
.collect-map {
	position: relative;
}

.progress-indicator {
	position: absolute;
	z-index: 1;
	top: 0;
	margin-top: 10px;
	margin-left: 10px;
	box-shadow: 0 0 0 2px rgba(0, 0, 0, 0.1);
}
</style>
